= nng_pipe_id(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_pipe_id - return numeric pipe identifier

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

int nng_pipe_id(nng_pipe p);
----

== DESCRIPTION

The `nng_pipe_id()` function returns a positive identifier for the pipe _p_,
if it is valid.
Otherwise it returns `-1`.

NOTE: A pipe is considered valid if it was ever created by the socket.
Pipes that are allocated on the stack or statically should be
initialized with the macro
xref:nng_pipe.5.adoc#NNG_PIPE_INITIALIZER[`NNG_PIPE_INITIALIZER`] to ensure that
they cannot be confused with a valid pipe.

== RETURN VALUES

This function returns the positive value for the pipe identifier, or
`-1` if the pipe is invalid.

== ERRORS

None.

== SEE ALSO

[.text-left]
xref:nng_pipe.5.adoc[nng_pipe(5)],
xref:nng.7.adoc[nng(7)]
